package foras.debug {
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	/**
	 * ...
	 * @author 4as
	 */
	public class ForDebugText extends Sprite {
		
		private static const DEBUG_GROUP:String = "default_debug";
		
		private static const tDebug:TextField = new TextField();
		private static const oDebug:Object = new Object();
		
		public function ForDebugText() {
			tDebug.autoSize = TextFieldAutoSize.LEFT;
			tDebug.multiline = true;
			tDebug.mouseEnabled = false;
			addChild(tDebug);
		}
		
		public static function getDebugCanvas():Sprite { return this; }
		
		/** Will just display whatever you pass as an argument */
		public static function setDebugText(s:String):void { main.tDebug.text = s; }
		/** Will add an debug text to specified group (no group = "default") */
		public static function addDebugText(s:String,group:String=null):void {
			//main.tDebug.appendText("\n" + s);
			if(group == null) group = DEBUG_GROUP;
			if(oDebug[group] == null) oDebug[group] = ""; //this needs to be here to create the first var
			oDebug[group] += s +"\n";
		}
		/** Displays all the debug text that was added through "addDebugText" */
		public static function commitDebugText():void {
			var s:String = "";
			for(var key:String in oDebug) {
				s += oDebug[key];
			}
			tDebug.text = s;
		}
		/** Cleans the specified group from all the text */
		public static function resetDebugText(group:String = null):void {
			if(group == null) {
				for(var key:String in oDebug) {
					delete oDebug[key];
				}
			} else {
				delete oDebug[group];
			}
		}
		
	}

}