package foras.debug {
	/** Returns the time it took (in ms) for 'fun' to be processed in 'reapet' number of times */
	function measureProcessTime(fun:Function, repeat:int = 10):Number {
		var time:Number = getTimer();
		for(var i:int = 0; i < repeat; i++) {
			fun();
		}
		return getTimer() - time;
	}
}