package foras.for3d {
	import flash.utils.ByteArray;
	import flash.utils.Endian;
	
	public class For3DShader {
		
		private const aVertex:Array = [ -96, 1, 0, 0, 0, -95, 0, 24, 0, 0, 0, 0, 0, 15, 3, 0, 0, 0, -28, 0, 0, 0, 0, 0, 0, 0, -28, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 4, 1, 0, 0, -28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
		private const aFrag:Array = [ -96, 1, 0, 0, 0, -95, 1, 0, 0, 0, 0, 0, 0, 15, 3, 0, 0, 0, -28, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
		
		public function For3DShader() {
			
		}
		
		public function getVertexShader():ByteArray {
			var ba:ByteArray = new ByteArray();
			ba.endian = Endian.LITTLE_ENDIAN;
			var i:int = 0;
			while (i < aVertex.length) {
				ba.writeByte(aVertex[i]);
				i++;
			}
			return ba;
		}
		
		public function getFragmentShader():ByteArray {
			var ba:ByteArray = new ByteArray();
			ba.endian = Endian.LITTLE_ENDIAN;
			var i:int = 0;
			while (i < aFrag.length) {
				ba.writeByte(aFrag[i]);
				i++;
			}
			return ba;
		}
		
	}

}