﻿package foras.tools.core {
	public class ForFireworkSpark {		
		public var x:Number;
		public var y:Number;
		private var fCall:Function;
		private var nVecX:Number;
		private var nVecY:Number;
		private var nShift:Number;
		private var nRot:Number;
		private var nGrav:Number;
		public function ForFireworkSpark(rotation:Number,spread:Number) {
			x = 0;
			y = 0;
			nShift = spread;
			setRotation(rotation);
			nGrav = 0;
		}
		public function addRotation(rot:Number):void {
			setRotation(nRot + rot);
		}
		public function setRotation(rot:Number):void {
			nRot = rot;
			nVecX = Math.cos(rot);
			nVecY = Math.sin(rot);
		}
		public function addGravity(grav:Number):void {
			setGravity(nGrav+grav);
		}
		public function setGravity(grav:Number):void {
			nGrav = grav;
		}
		public function process(speed:Number):void {
			x += nVecX * speed*nShift;
			y += (nVecY * speed*nShift) + nGrav;
		}
		public function clone():ForFireworkSpark {
			var spark:ForFireworkSpark = new ForFireworkSpark(nRot,nShift);
			spark.x = x;
			spark.y = y;
			return spark;
		}
	}
}