﻿package foras.ui.basic {
	
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	
	public class ForUIButton extends ForUI {
		
		public static const BUTTON_PRESSED:Number = 0xff020001;

		public function ForUIButton() {
			gotoAndStop(1);
		}
		
		override public function init(callback:Function=null):void {
			super.init(callback);
			addEventListener(MouseEvent.MOUSE_OVER,eventOver);
			addEventListener(MouseEvent.MOUSE_OUT,eventOut);
			addEventListener(MouseEvent.MOUSE_DOWN,eventPress);
			addEventListener(MouseEvent.MOUSE_UP,eventRelease);
		}
		override public function close():void {
			removeEventListener(MouseEvent.MOUSE_OVER,eventOver);
			removeEventListener(MouseEvent.MOUSE_OUT,eventOut);
			removeEventListener(MouseEvent.MOUSE_DOWN,eventPress);
			removeEventListener(MouseEvent.MOUSE_UP,eventRelease);
			super.close();
		}
		
		private function eventOver(e:MouseEvent):void {
			if(e.buttonDown) return;
			gotoAndStop(2);
		}
		private function eventOut(e:MouseEvent):void {
			gotoAndStop(1);
		}
		private function eventPress(e:MouseEvent):void {
			gotoAndStop(3);
		}
		private function eventRelease(e:MouseEvent):void {
			gotoAndStop(2);
			callback(BUTTON_PRESSED,this,this);
		}

	}
	
}
