package foras.for3d {
	
	import flash.geom.Matrix3D;

	public function get3DProjection(fieldOfViewY:Number, aspectRatio:Number, zNear:Number, zFar:Number):Matrix3D {
			var yScale:Number = 1.0/Math.tan(fieldOfViewY/2.0);
			var xScale:Number = yScale / aspectRatio; 
			return new Matrix3D( Vector.<Number>([
				xScale, 0.0, 0.0, 0.0,
				0.0, yScale, 0.0, 0.0,
				0.0, 0.0, zFar/(zNear-zFar), -1.0,
				0.0, 0.0, (zNear*zFar)/(zNear-zFar), 0.0
			]) );
		}
	
}