﻿package foras.tools.core {
	public class ForFireworkRocket {
		public var x:Number;
		public var y:Number;
		
		private var fCall:Function;
		
		private var nColor:Number;
		private var nSpeed:Number;
		private var nLife:int;
		private var nSpeedMin:Number
		
		public function ForFireworkRocket(settings:ForFireworkSettings):void {
			x = 0;
			y = 0;
			nSpeed = settings.rocketSpeed;
			nLife = settings.rocketLife;
			nColor = settings.color;
			nSpeedMin = settings.rocketSpeedStop;
		}
		public function init(callback:Function):void {
			fCall = callback;
		}
		public function process(grav:Number):void {
			if(fCall == null) return;
			nLife --;
			if(nLife <= 0) fCall();
			nSpeed -= grav;
			y -= nSpeed;
			if(nSpeed <= nSpeedMin) fCall();
		}
		public function getColor():Number { return nColor; }
	}
}