﻿package foras.ui {
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFieldAutoSize;
	
	public class ForUIConsole extends TextField {
		
		private var aItems:Vector.<String>;
		private var nLength:uint;
		
		public function ForUIConsole(len:uint = 5):void {
			super();
			
			nLength = len;
			width = 400;
			height = 14*nLength;
			mouseEnabled = false;
			
			antiAliasType = AntiAliasType.ADVANCED;
			autoSize = TextFieldAutoSize.LEFT;
			multiline = true;
			selectable = false;
			embedFonts = false;
			textColor = 0;
			
			aItems = new Vector.<String>(nLength,true);
			
		}
		
		public function setFormat(format:TextFormat):void {
			this.setTextFormat(format);
			this.defaultTextFormat = format;
			this.height = Number(format.size)*aItems.length;
		}
		public function setLength(l:Number):void {
			
		}
		public function getLength():uint {
			return nLength;
		}
		
		public function addMessage(msg:String):void {
			var i:uint = 0;
			while(i<nLength-1) {
				aItems[i] = aItems[i+1];
				++i;
			}
			aItems[i] = msg;
			
			text = "";
			
			i = 0;
			while(i<nLength) {
				if(aItems[i]!=null) appendText(aItems[i]+"\n");
				++i;
			}
		}
		
	}
}