﻿package foras.ui {
	
	import foras.ui.basic.ForUI;
	import foras.ui.basic.ForUIButton;
	
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	
	public class ForUIMessage extends ForUI {
		
		public static const MESSAGE_ACCEPT:Number = 0xff010001;
		
		//public var tLabel:TextField;
		//public var tMessage:TextField;
		//public var fb_Button:ForUIButton;
		
		private var nID:Number;

		public function ForUIMessage() {
			gotoAndStop(1);
			nID = MESSAGE_ACCEPT;
		}
		
		override public function init(callback:Function=null):void {
			super.init(callback);
			buttonAccept.init(eventButton);
			addEventListener(MouseEvent.MOUSE_DOWN,eventPress);
			stage.addEventListener(MouseEvent.MOUSE_UP,eventStop);
		}
		override public function close():void {
			removeEventListener(MouseEvent.MOUSE_DOWN,eventPress);
			stage.removeEventListener(MouseEvent.MOUSE_UP,eventStop);
			buttonAccept.close();
			super.close();
		}
		
		// Setter and Getters
		public function setMessage(label:String,msg:String):void {
			textLabel.text = label;
			textMessage.text = msg;
		}
		
		public function get buttonAccept():ForUIButton {
			return fb_Button;
		}
		public function get textLabel():TextField {
			return tLabel;
		}
		public function get textMessage():TextField {
			return tMessage;
		}
		
		// Events
		private function eventButton(id:Number,res:Object = null,ref:Object = null):void {
			callback(MESSAGE_ACCEPT,this);
		}
		
		private function eventPress(e:MouseEvent):void {
			if(e.target != buttonAccept) startDrag();
		}
		private function eventStop(e:MouseEvent):void {
			stopDrag();
		}

	}
	
}
