package foras.utils {

	public class ForRandomPick {
		
		private var link:ForLinkedList;
		private var arr:Array;
		
		public function ForRandomPick(list:Array) {
			arr = list;
			link = ForLinkedList.createFrom(arr);
		}
		public function reset():void {
			link = ForLinkedList.createFrom(arr);
		}
		public function blockIndex(idx:int):void {
			link.removeByValue(arr[idx]);
		}
		public function blockValue(val:*):void {
			link.removeByValue(val);
		}
		public function getSetSize():int {
			return link.length;
		}
		
		public function pick():* {
			var idx:int = int(Math.random() * link.length);
			return link.get(idx);
		}
		public function pickAndBlock():* {
			var idx:int = int(Math.random() * link.length);
			var o:* = link.get(idx);
			link.removeByIndex(idx);
			return o;
		}
		
		public static function pickFrom(size:int):int {
			return int(Math.random() * size);
		}
		
	}

}